/* ISD2500 Interface */
/* Cyrus Harrison (cdh@cise.ufl.edu) */

#include <io.h>
#include <progmem.h>
#include "isd2500.h"
#include "timer.h"

/*
   PORTC Bit Ordering 
   0  1   2  3   4  5  6   
   A4 A5 A6 A7	CE PD  P/R 
*/

void isd_init()
{outp(0xFF, PORTC);}

void isd_record_start(unsigned char addy)
{
/*P/~R = Low  */
/*PD   = Low  */
/*Addy = addy */
/*CE   = Low  */

outp(addy | 0x70,PORTC);
timer_block_for(2);
outp(addy | 0x10,PORTC);
timer_block_for(2);
outp(addy | 0x0,PORTC);

}

void isd_record_stop()
{
/*CE   = High  */
outp(inp(PORTC) | 0x10,PORTC);
timer_block_for(2);
outp(0xFF,PORTC);
}


void isd_play(unsigned char addy)
{

/*P/~R = High */
/*PD   = Low  */
/*Addy = addy */
/*CE   = Low  */
outp(addy | 0x70,PORTC);
timer_block_for(2);

outp(addy | 0x40,PORTC);
/*CE   = High */

timer_block_for(2);
outp(addy | 0x50,PORTC); 

}


