/*
    Ranzors Brain
*/
/* Cyrus Harrison (cdh@cise.ufl.edu) */

#include <progmem.h>
#include "uart.h"
#include "adc.h"
#include "servos.h"
#include "rf.h"
#include "isd2500.h"
#include "timer.h"



void find_edge(void)
{

			unsigned char  bump_val;
			unsigned short bbeam_val,leye_val,reye_val;
			unsigned char  edge=0;
			drive_servos_start();
			drive_forward();
     			
     			while(edge!=1)
     			{
     				
     				leye_val  = SAMP_LEYE;
     				reye_val  = SAMP_REYE;
     				bbeam_val = SAMP_BBEAM;
     				bump_val  = SAMP_BUMP;
     				
     				
     				if(bump_val==0)
     				{
     					if(bbeam_val<BROKEN && leye_val<=LEYE_THRESHOLD && reye_val<=REYE_THRESHOLD)
     					{
     						drive_servos_stop();
     						drive_left();
     						drive_servos_start();
     						edge=1;	
     						timer_block_for(75);
     						
     						/*edge found*/
     						
     					}else{		
     							
     						if(leye_val<=LEYE_THRESHOLD && !(reye_val<=REYE_THRESHOLD)){
     				
     							/*PRINT("Left Eye off Table");EOL();*/
     							drive_left();
							timer_block_for(5);
     			
     						}else if(reye_val<=REYE_THRESHOLD && !(leye_val<=LEYE_THRESHOLD)){
     							
     							/*PRINT("Right Eye off Table");EOL();*/
     							drive_right();
  							timer_block_for(5);
  
     						}else{drive_forward();}
     					}

     					
     				}else if(bump_val==1 || bump_val==0x8 || bump_val==0x4){
  					/*Stop*/
  					drive_servos_stop();   
  									
     			
     				}else if(bump_val==2){
     					/*Start Again*/
     					drive_servos_start();
     				}
     			
     				/*Wait a little bit*/
     			     	timer_block_for(5);
     			
     			}


}




void reset_lift(void)
{
 camera_up();
 outp(0x20,PORTD); /* turn off staging light */
}

void start_req(unsigned char mode)
{
 unsigned char rf_val=0;
 unsigned char bump_val=0;
 unsigned char time_out=0;
 unsigned char time_thres=0;
 
 drive_servos_stop();
 camera_down();
 outp(0x00,PORTD); /* turn on staging light */
 
 isd_play(ISD_SP_DIE_FOUND);
 /*PRINT("Starting Recog");EOL();*/
 /*Wait for a req*/
 
 /*
 rf_pdn();
 timer_block_for(10);
 rf_pup();
 */
 
 timer_block_for(200);
 time_thres=timer_ticks()+254;
 
 while(rf_val==0 && bump_val!=0x8 && time_out!=2)
 {
 	rf_val=rf_read();
 	bump_val=SAMP_BUMP;
 	timer_block_for(10);
 	
 	if(time_thres==timer_ticks())
 	{
 	time_out++;time_thres+=254;
 	/*PRINT("<Time out occured>");EOL();*/
 	}
 }
 
 /*PRINT("Out of Rcv Block");EOL();*/
 
 /*Display Value*/

if(rf_val>0 && rf_val <7)
{
  	/*PRINT("RF Data Recieved");EOL();PRINT("Value: ");*/
  	
  	isd_play(ISD_SP_VALUE);
  	timer_block_until(timer_ticks()+100);
  	
  	UART_Printfu08(rf_val);EOL();
  	
  	isd_play(rf_val);
  	/*PRINT("Blocking");EOL();*/
  	timer_block_for(100);

  	/*PRINT("Resetting Lift");EOL();*/
  	reset_lift();
 	
 	/*rf_pdn();*/
 	timer_block_for(75);
	/*rf_pup();*/
 	
 	rf_val=0x0;
  	while(rf_val!=0x0)
  	{
  		rf_val=rf_read();
  		UART_Printfu08(rf_val);
  	}
  	
 
 } else {/*end via bump*/ ; }
 
 	reset_lift();
 	/*
 	if(mode==1)
 	{
 		
 
 		drive_backward();
 		timer_block_for(10);
 		drive_servos_start();
 		
 		
 		timer_block_for(100);
 		
 		
 		drive_right();
 	
 		
 		timer_block_for(30);
 		
 		
 		drive_forward();
 	
 	
 	}else{
    		//rf_pdn();
 		timer_block_for(10);
 		//rf_pup();
    	}*/
 	
}


/*Ranzor's Collison Avoidance*/
void autonomous(void)
{
			unsigned char  bump_val;
			unsigned short bbeam_val,leye_val,reye_val;
			
			drive_servos_start();
			drive_forward();
     			isd_play(ISD_SP_SEARCHING);
     			
     			while(1)
     			{
     				
     				leye_val  = SAMP_LEYE;
     				reye_val  = SAMP_REYE;
     				bbeam_val = SAMP_BBEAM;
     				bump_val  = SAMP_BUMP;
     				
     				
     				if(bump_val==0)
     				{
     					if(bbeam_val>=BROKEN)
     					{
     						/*PRINT("Break Beam Broken");EOL();*/
     						timer_block_for(10);
     						start_req(1);
     						find_edge();
     						isd_play(ISD_SP_SEARCHING);
     						
     					}else{			
     						if(leye_val<LEYE_THRESHOLD){
     				
     							/*PRINT("Left Eye off Table");EOL();*/
     							drive_right();
							timer_block_for(25);
     			
     						}else if(reye_val<REYE_THRESHOLD){
     							
     							/*PRINT("Right Eye off Table");EOL();*/
     							drive_left();
  							timer_block_for(25);
  
     						}else{drive_forward();}
     					}

     					
     				}else if(bump_val==1 || bump_val==0x8 || bump_val==0x4){
  					/*Stop*/
  					drive_servos_stop();   
  					reset_lift();  					
     			
     				}else if(bump_val==2){
     					/*Start Again*/
     					drive_servos_start();
     				}
     			
     				/*Wait a little bit*/
     			     	timer_block_for(5);
     			
     			}
}





void test_interface(void)
{
	unsigned char uart_data;
	unsigned short adc_data;
	unsigned short leye_max,leye_min;
	unsigned short reye_max,reye_min;

	PRINT("<Menu>");EOL();
	PRINT("Sample ADC Port <a>");EOL();
	PRINT("Control Drive Servos <b>");EOL();
	PRINT("Observe IR Eye Values <c>");EOL();
	PRINT("Read from RF <d>");EOL();
	PRINT("Read Bump Switches <e>");EOL();
	PRINT("Test Timer <f>");EOL();
	PRINT("ISD 2500 Interface <g>");EOL();
	PRINT("Test Staging Light <h>");EOL();

	
	PRINT("Enter your selection: ");
        uart_data = UART_ReceiveByte();
  	EOL();  
        PRINT("You pressed '");
        UART_SendByte(uart_data);
        PRINT("' which is 0x");
        UART_Printfu08(uart_data);
        PRINT(" in hexadecimal.");EOL();
        
        
        if(uart_data=='a')
        {
        	PRINT("You Picked a (Sample ADC Port)");EOL();
         	
         	PRINT("Please Enter Which Port");
         	uart_data=UART_ReceiveByte();
         	EOL();
         	uart_data=uart_data-0x31;
         	PRINT("You Picked Port: ");
         	UART_Printfu08(uart_data);
        	EOL();
         	
         	PRINT("Port Data: ");EOL();
         	
         	adc_data=adc_sample(uart_data);
         	UART_Printfu16(adc_data);
     
         	EOL();
     	}else if(uart_data=='b'){
     		
     		PRINT("You Picked b (Control Drive Servos)");EOL();
     		while(uart_data!='q')
     		{
     		
     		PRINT("Wheels Menu <l>eft speed or <r>ight speed <l>ift servo <S>tart <s>top  <b>ehaviors <a>utonomous or <q>uit");EOL();
     		uart_data=UART_ReceiveByte();
     		
  
     		if(uart_data=='l')
     		{
     			PRINT("Current PWM Value: ");
     			UART_Printfu08(get_lwheel_speed());EOL();
     			
    			PRINT("Options: ");EOL();
    			PRINT("<1> Add 1");EOL();
    			PRINT("<2> Add 2");EOL();
    			PRINT("<3> Sub 1");EOL();
    			PRINT("<4> Sub 2");EOL();
    			uart_data=UART_ReceiveByte();
    			EOL();
    			
    			/* Min:  	0x08 */
    			/* Stop:     	     */
    			/* Max: 	0x19 */
    			switch(uart_data)
    			{
    				case '1':
    					set_lwheel_speed((get_lwheel_speed()+1));
    				break;
    				
    				case '2':
    					set_lwheel_speed((get_lwheel_speed()+2));
    				break;
    				
    				case '3':
    					set_lwheel_speed((get_lwheel_speed()-1));
    				break;
    				
    				case '4':
    					set_lwheel_speed((get_lwheel_speed()-2));
    				break;
    				
    				
    			}
    			
    		
     		}else if(uart_data=='r'){
     		
     			PRINT("Current PWM Value: ");
     			UART_Printfu08(get_rwheel_speed());EOL();
     			
    			PRINT("Options: ");EOL();
    			PRINT("<1> Add 1");EOL();
    			PRINT("<2> Add 2");EOL();
    			PRINT("<3> Sub 1");EOL();
    			PRINT("<4> Sub 2");EOL();
    			uart_data=UART_ReceiveByte();
    			EOL();
    			
    			switch(uart_data)
    			{
    				case '1':
    					set_rwheel_speed((get_rwheel_speed()+1));
    				break;
    				
    				case '2':
    					set_rwheel_speed((get_rwheel_speed()+2));
    				break;
    				
    				case '3':
    					set_rwheel_speed((get_rwheel_speed()-1));
    				break;
    				
    				case '4':
    					set_rwheel_speed((get_rwheel_speed()-2));
    				break;
    				
    				
    			}
     		
     		}else if(uart_data=='l'){
     		
     			PRINT("Current PWM Value: ");
     			UART_Printfu08(get_lift_pos());EOL();
     			
    			PRINT("Options: ");EOL();
    			PRINT("<1> Add 1");EOL();
    			PRINT("<2> Add 2");EOL();
    			PRINT("<3> Sub 1");EOL();
    			PRINT("<4> Sub 2");EOL();
    			uart_data=UART_ReceiveByte();
    			EOL();
    			
    			switch(uart_data)
    			{
    				case '1':
    					set_lift_pos((get_lift_pos()+1));
    				break;
    				
    				case '2':
    					set_lift_pos((get_lift_pos()+2));
    				break;
    				
    				case '3':
    					set_lift_pos((get_lift_pos()-1));
    				break;
    				
    				case '4':
    					set_lift_pos((get_lift_pos()-2));
    				break;
    				
    				
    			}
     		
     		}else if(uart_data=='S'){
     			PRINT("Starting Drive Servos");EOL();
     			drive_servos_start();
     		}else if(uart_data=='s'){
     			drive_servos_stop();
     			PRINT("Stoping Drive Servos");EOL();
     		}else if(uart_data=='a'){
     			
     			autonomous();
     			
     		}else if(uart_data=='b')
     		{
     			drive_servos_stop();
     			
     			PRINT("Locomotion Behaviors: ");EOL();
     			
    			PRINT("Options: ");EOL();
    			PRINT("<1> Forward");EOL();
    			PRINT("<2> Backward");EOL();
    			PRINT("<3> Left");EOL();
    			PRINT("<4> Right");EOL();
    			PRINT("<5> Stop");EOL();
    			uart_data=UART_ReceiveByte();
    			
    			switch(uart_data)
    			{
    				case '1':
    					/*drive_forward*/
    					set_rwheel_speed(0x18);
    					set_lwheel_speed(0x08);
    				break;
    				
    				case '2':
    					/*drive_backward*/
    					set_rwheel_speed(0x08);
    					set_lwheel_speed(0x18);
    				break;
    				
    				case '3':
    					/*turn_left*/
    					set_rwheel_speed(0x18);
    					set_lwheel_speed(0x18);
    				break;
    				
    				case '4':
    					/*turn_right */
    					set_rwheel_speed(0x08);
    					set_lwheel_speed(0x08);
    				case '5':
    					drive_servos_stop();
    				break;
    				
    				
    			}
    			drive_servos_start();
			}
		}
   
     
     	
     		}else if(uart_data=='c'){
     		
     			leye_max=0x0000;leye_min=0xFFFF;
     			reye_max=0x0000;reye_min=0xFFFF;
     			
     			while(1)
     			{
     			PRINT("Left Eye: ");
     			adc_data=adc_sample(0);
     			UART_Printfu16(adc_data);EOL();
     			
     			if(adc_data<leye_min){leye_min=adc_data;}
     			if(adc_data>leye_max){leye_max=adc_data;}
     			PRINT(" LMIN:");UART_Printfu16(leye_min); PRINT(" LMAX:");UART_Printfu16(leye_max);EOL();
     			
     			PRINT("Right Eye: ");
     			adc_data=adc_sample(1);
     			UART_Printfu16(adc_data);EOL();
     			
     			if(adc_data<reye_min){reye_min=adc_data;}
     			if(adc_data>reye_max){reye_max=adc_data;}
     			PRINT(" RMIN:");UART_Printfu16(reye_min); PRINT(" RMAX:");UART_Printfu16(reye_max);EOL();     			
     			
     			}
     	
		}else if(uart_data=='d'){
		
		PRINT("Current RF Nibble:");EOL();
		UART_Printfu08(rf_read());
    		EOL();
		
					
		}else if(uart_data=='e'){
		
	
		PRINT("Bump Values ");
		UART_Printfu08(bump_resolve(adc_sample(7)));
		EOL();
		
		
		}else if(uart_data=='f'){
		
		PRINT("Blocking for 1/2 of a second");

		uart_data=timer_ticks();
		timer_start();
		timer_block_until(uart_data + 50);
		PRINT("Ticks After ");
		UART_Printfu08(timer_ticks());EOL();
		PRINT("Ticks Before ");
		UART_Printfu08(uart_data);EOL();
		
		PRINT("Blocking for 1 a second");

		uart_data=timer_ticks();
		timer_start();
		timer_block_until(uart_data + 100);
		PRINT("Ticks After ");
		UART_Printfu08(timer_ticks());EOL();
		PRINT("Ticks Before ");
		UART_Printfu08(uart_data);EOL();
		
		PRINT("Blocking for 2 seconds");

		uart_data=timer_ticks();
		timer_start();
		timer_block_until(uart_data + 200);
		PRINT("Ticks After ");
		UART_Printfu08(timer_ticks());EOL();
		PRINT("Ticks Before ");
		UART_Printfu08(uart_data);EOL();
		
		}else if(uart_data=='g'){
		
		PRINT("ISD 2500 Interface");EOL();
		PRINT("<1> Record");EOL();
		PRINT("<2> Play");EOL();
		uart_data=UART_ReceiveByte();
    			
    			switch(uart_data)
    			{
    				case '1':
 				PRINT("Input Address:");
 				uart_data=UART_ReceiveByte();
 				uart_data= uart_data - 0x30;		
 				
 				PRINT("Recording , Press any key to stop");EOL();
 				isd_record_start(uart_data);
 				UART_ReceiveByte();
 				isd_record_stop();
 				
 						   				
    				break;
    				
    				case '2':
    				PRINT("Input Address:");
 				uart_data=UART_ReceiveByte();
 				uart_data= uart_data - 0x30;		
 				PRINT("Playing");EOL();
 				isd_play(uart_data);
    				break;
    				
    				
    				
    			}
		
		}else if(uart_data=='h'){
		
		PRINT("Power Switches:");EOL();
		PRINT("Staging light on  <1>");EOL();
		PRINT("Staging light off <2>");EOL();
		uart_data=UART_ReceiveByte();
			switch(uart_data)
			{
				case '1':
				PRINT("Turning Staging light on");EOL();
				outp(0x00,PORTD);
				break;

				case '2':
				PRINT("Turning Staging light off");EOL();
				outp(0x20,PORTD);
				break;
			}
		
		
     		
        }else{
        PRINT("UNKNOWN ENTRY!");EOL();
        }
        
       

}




int main(void)
{
    unsigned char rf_prev=0x0;
    /*Init Stuff*/
    isd_init();
    rf_init();
    timer_init();
    timer_start();
    UART_Init();
    ADC_Init();
    drive_servos_init();
    set_lift_pos(0x18);
    lift_servo_start();
    
    isd_play(ISD_SP_ONLINE);
    timer_block_until(timer_ticks() + 255);
    
			while(1)
			{
			
			if(bump_resolve(adc_sample(7))==1){
		   
     				while(1)
     				{
		     			test_interface();
     				}
    	
    			}else if(bump_resolve(adc_sample(7))==2){
    				autonomous();
    				
    			}else if(bump_resolve(adc_sample(7))==4){
    			
    				start_req(0);
    			
    			}else if(bump_resolve(adc_sample(7))==8){
    			
    				reset_lift();
    			
    				
    			}else{
    			
    				drive_servos_stop();
    				
    				
    			}
    			
    			if((rf_read() >0 && rf_read()<7)&& rf_read()!=rf_prev)
    				{
    				rf_prev=rf_read();
    				isd_play(rf_read());
    				}
    			
  
    			}
    
}

