/*
Global Servo Functions
*/
/* Cyrus Harrison (cdh@cise.ufl.edu) */

/* Wheel Setup */
extern void 		drive_servos_init	(void);
extern void		drive_servos_start	(void);
extern void		drive_servos_stop	(void);


/*Low Level Wheel Interface*/
extern unsigned char	get_lwheel_speed	(void);
extern unsigned char	get_rwheel_speed	(void);

extern void		set_lwheel_speed	(unsigned char val);
extern void		set_rwheel_speed	(unsigned char val);


/*High Level Wheel Interface */
extern void 		drive_forward		(void);
extern void 		drive_backward		(void);
extern void 		drive_right		(void);
extern void 		drive_left		(void);

/* Lift Servo Interface*/
extern void		lift_servo_start	(void);
extern void		lift_servo_stop		(void);

/*Low Level Lift Servo Interface*/
extern unsigned char 	get_lift_pos		(void);
extern void		set_lift_pos		(unsigned char val);

/* High Level Lift Servo Interface*/
extern void		camera_up		(void);
extern void		camera_down		(void);

