/*
10ms Tick Timer Functions
*/
/* Cyrus Harrison (cdh@cise.ufl.edu) */
#include <io.h>
#include <progmem.h>
#include <interrupt.h>
#include <sig-avr.h>
#include "timer.h"

unsigned char timer_on;
unsigned char overflow_cntr;

void timer_init(void)
{
	/*Set up timer 0 for 10ms Over Flow timer*/	
	/*  Divide By 256*/
	outp(0x26,TCCR0);
	/* Enable Timer Over Flow Interrup*/
	outp(0x01,TIMSK);
	timer_on=0;
	overflow_cntr=0;
}


/*Interrupt Handler for Timer Overflow*/
SIGNAL(SIG_OVERFLOW0)      
{
	if(timer_on){overflow_cntr++;}
	/*Clear the TOV0 Interrupt Flag*/
	outp(0x1,TIFR);
}


void timer_start(void){timer_on=1;}
void timer_stop(void){timer_on=0;}
unsigned char timer_ticks(void){return overflow_cntr;}

void timer_block_until(unsigned char ticks)
{while(ticks!=timer_ticks());}

void timer_block_for(unsigned char ticks)
{timer_block_until(timer_ticks() + ticks);}

unsigned char xrand(void)
{return inp(TCNT0) & 0x1;}

