#ifndef __UART_H__
#define __UART_H__

/* UART Baud rate calculation */
#define UART_CPU               6000000      /* 6Mhz */
#define UART_BAUD_RATE         9600         /* baud rate*/
#define UART_BAUD_SELECT       (UART_CPU/(UART_BAUD_RATE*16l)-1)

/* Global functions */
extern void UART_SendByte       (unsigned char  Data);
extern unsigned char  UART_ReceiveByte    (void);
extern void UART_PrintfProgStr  (unsigned char* pBuf);
extern void UART_PrintfEndOfLine(void);
extern void UART_Printfu08      (unsigned char  Data);
extern void UART_Printfu16      (unsigned short  Data);
extern void UART_Init           (void);


/* Macros */
#define PRINT(string) (UART_PrintfProgStr(PSTR(string)))
#define EOL           UART_PrintfEndOfLine
#endif

